/*
 * Project name: PIC_IO02
 * File:   main.c
 * Author: TVC
 *
 * Created on 2015/06/03, 16:16
 * 쐬: 2015/06/08, 15:01
 * XV: 2015/06/08, 15:01
 * Version: 1.0
 * CPU: PIC16F1827
 * NbN: 32MHz
 * RpC: XC8
 *
 * Tv
 *  RA6ɐڑ[0.5bԊuONAOFFA[ɐڑLED_ł
 *  TMR0荞ݎgp
 *   NbN		32MHz
 *   ^C}0gp	32us*256=8.192ms
 *   vXP[	1:256
 *  gpI/O|[g
 *   RA6: [
 */


#include <xc.h>
#include <stdio.h>


// vg^Cv錾
static void interrupt intTMR0(void);
static void init();

// O[oϐ
// ^C}JEgݒ
static unsigned char count;	// 8.192ms*61=499.712ms500ms
// ^C}JEgtO
static		bit  tcFlg;     // 500mstO


// CONFIG1
#pragma config FOSC = INTOSC    // U gp
#pragma config WDTE = OFF       // EHb`hbO^C} 
#pragma config PWRTE = OFF      // p[Abv^C} 
#pragma config MCLRE = ON       // MCLR gpiOZbgLj
#pragma config CP = OFF         // tbVvOveNg 
#pragma config CPD = OFF        // f[^veNg 
#pragma config BOREN = ON       // uEAEg Zbg L
#pragma config CLKOUTEN = OFF   // NbNAEg iI/O܂͔Uj
#pragma config IESO = OFF       // Internal/External Switchover iNɓNbNœ삵AONbN̗オŊONbNɐؑւj
#pragma config FCMEN = OFF      // tFCZ[tNbNj^ iONbNĎAُ킪ΓNbNœj

// CONFIG2
#pragma config WRT = OFF        // tbV CgveNg 
#pragma config PLLEN = ON       // 4x PLL@\ L
#pragma config STVREN = ON      //Stack Overflow/Underflow Reset L
#pragma config BORV = LO        // uEAEgEZbgdI iuEAEgEZbgd(Vbor)AlowIj
#pragma config LVP = OFF        // dvO~O 


/*
 ******************************
 * ^C}0荞ݏ         *
 ******************************
 */
static void interrupt intTMR0(void) {
    T0IF = 0;	// TMR0荞݃NA
    count--;    // TMR0荞ݖɁAcount̒l1炷
    if	(count == 0) {  // 61JEgA500msoߏ
	count = 61;	// Ă61Zbg
	tcFlg = 1;	// 500mStOZbg
    }
}



/*
 ****************************************
 * C                           *
 ****************************************
 */
void main(void) {

    init();     // PIC
   
    count = 61; // ^C}JEg61ɐݒ
    tcFlg = 0;  // ^C}JEgtONA

    while(1) {  // [ONAOFFJԂ
        if (tcFlg) {    // ^C}JEgtO"1"(500mso)ȂAȉ
            tcFlg = 0;  // ^C}JEgtONA
            if (PORTAbits.RA6 == 0) {   // [OFF(0)ĂAȉ
                PORTAbits.RA6 = 1;      // [ON
            } else {                // ONȂAȉ
                PORTAbits.RA6 = 0;  // [OFF
            }
        }
    }
    return;
}


/*
 ******************************
 * CjVCY          *
 ******************************
*/
static void init() {

    // PICNbNgݒ
    OSCCON=0b01110000;  // IV[^8MHzI

    //|[g̏
    PORTA = 0x00;       // PORTANA
    TRISA = 0x00;       // PORTȂSĂbit0: o ɐݒ
    ANSELA = 0b00000000; // RA4-RA0͑S0: fW^I/OƂĎgp
    ANSELB = 0b00000000; // RB7-RB1͑S0: fW^I/OƂĎgp

    // ^C}0ƃEHb`hbO^C}̐ݒAEHb`hbO^C}͎gpȂ
    OPTION_REG = 0x87;  // ^C}0[hIAvXP[ 1:256 ɐݒ
    TMR0 = 0x00;        // ^C}0JE^NAB̐ݒɂ^C}0́A32us*256=8.192msɊ荞݂B

    // 荞ݐݒ
    T0IE = 1;		// ^C}0(TMR0)荞݋
    GIE = 1;		// S̊荞݋
}
